-- CXL Layout File Tool Functions.
-- version 1.0
-- by Altiris 2012
---------------------------------------------------------------------------------------------------------------------------------------------------


global workingdir = (getDir #maxroot) + "Altiris"
--


---------------------------------------------------------------------------------------------------------------------------------------------------		
---------------------------------------------------------------------------------------------------------------------------------------------------						
fn AddTrees tempfile = 
(
	local TreeName = ReadCXLFile "Tree" "Name"
	local TreeID = ReadCXLFile "Tree" "ID"
	local TreeProto = ReadCXLFile "Tree" "Proto"
	
	for i = 1 to helpers.count do
	(
		if (helpers[i].name != undefined) and (classof helpers[i] == CXLTREE) then
		(		
			id   = "\t\t<ID>" + helpers[i].name + "</ID>\n"
			type = "\t\t<Type>TREE</Type>\n"
			pos  = "\t\t<Position>" + (helpers[i].pos.x /100)as string + "," + (helpers[i].pos.y /100)as string + "," + (helpers[i].pos.z /100)as string + "</Position>\n"
			rot  = "\t\t<Rotation>" + helpers[i].rotation.x as string + "," + helpers[i].rotation.y as string + "," + helpers[i].rotation.z as string + "," + helpers[i].rotation.w as string + "</Rotation>\n"
			resource = "\t\t\t<ResourceFile>" + TreeProto[helpers[i].species] + "</ResourceFile>\n"
			presence = "\t\t\t<PresenceProbability>" + ( helpers[i].presence as Float / 100) as string + "</PresenceProbability>\n"	
			scalestr = ( helpers[i].treescale as Float / 100) as string + "," + ( helpers[i].treescale as Float / 100) as string + "," + ( helpers[i].treescale as Float / 100) as string
			treescale = "\t\t<Scale>" + scalestr + "</Scale>\n"
			scalemin = "\t\t\t<ScaleRandom_Min>" + ( helpers[i].scalemin as Float / 100) as string + "</ScaleRandom_Min>\n"
			scalemax = "\t\t\t<ScaleRandom_Max>" + ( helpers[i].scalemax as Float / 100) as string + "</ScaleRandom_Max>\n" 
			proto = "\t\t<PrototypeFile>data/design/decoration/tree/tree.class</PrototypeFile>\n"
			format "\t<LayoutEntry>\n" to: tempfile				
			format id to: tempfile				
			format type to: tempfile				
			format proto to: tempfile				
			format pos to: tempfile				
			format rot to: tempfile		
			format treescale to: tempfile		
			format "\t\t<Tree>\n" to: tempfile			
			format resource to: tempfile
			format presence to: tempfile
			format scalemin to: tempfile
			format scalemax to: tempfile		
			format "\t\t</Tree>\n\t</LayoutEntry>\n" to: tempfile			
		)
	)	
)


---------------------------------------------------------------------------------------------------------------------------------------------------		
---------------------------------------------------------------------------------------------------------------------------------------------------						
fn AddFurnitures tempfile = 
(
	local FurnitureName = ReadCXLFile "Furniture" "Name"
	local FurnitureID = ReadCXLFile "Furniture" "ID"
	local FurnitureProto = ReadCXLFile "Furniture" "Proto"
	
	for i = 1 to helpers.count do
	(
		if (helpers[i].name != undefined) and (classof helpers[i] == CXLFURNITURE) then
		(		
			id   = "\t\t<ID>" + helpers[i].name + "</ID>\n"
			type = "\t\t<Type>FURNITURE</Type>\n"
			pos  = "\t\t<Position>" + (helpers[i].pos.x /100)as string + "," + (helpers[i].pos.y /100)as string + "," + (helpers[i].pos.z /100)as string + "</Position>\n"
			rot  = "\t\t<Rotation>" + helpers[i].rotation.x as string + "," + helpers[i].rotation.y as string + "," + helpers[i].rotation.z as string + "," + helpers[i].rotation.w as string + "</Rotation>\n"
			prototype = "\t\t<PrototypeFile>" + FurnitureProto[helpers[i].furnituretype] + "</PrototypeFile>\n"
			presence = "\t\t\t<PresenceProbability>" + ( helpers[i].presence as Float / 100) as string + "</PresenceProbability>\n"	
			scalestr = ( helpers[i].furniturescale as Float / 100) as string + "," + ( helpers[i].furniturescale as Float / 100) as string + "," + ( helpers[i].furniturescale as Float / 100) as string
			furniturescale = "\t\t<Scale>" + scalestr + "</Scale>\n"
			
			format "\t<LayoutEntry>\n" to: tempfile				
			format id to: tempfile				
			format type to: tempfile				
			format prototype to: tempfile				
			format pos to: tempfile				
			format rot to: tempfile		
			format furniturescale to: tempfile		
			format "\t\t<Furniture>\n" to: tempfile			
			format presence to: tempfile	
			format "\t\t</Furniture>\n\t</LayoutEntry>\n" to: tempfile			
		)
	)	
)


---------------------------------------------------------------------------------------------------------------------------------------------------		
---------------------------------------------------------------------------------------------------------------------------------------------------						
fn AddActors tempfile = 
(
	local ActorName = ReadCXLFile "Actor" "Name"
	local ActorID = ReadCXLFile "Actor" "ID"
	local ActorProto = ReadCXLFile "Actor" "Proto"
	
	for i = 1 to helpers.count do
	(
		if (helpers[i].name != undefined) and (classof helpers[i] == CXLACTOR) then
		(		
			id   = "\t\t<ID>" + helpers[i].name + "</ID>\n"
			type = "\t\t<Type>ACTOR</Type>\n"
			prototypefile = "\t\t<PrototypeFile>data/design/editor/actor.class</PrototypeFile>\n"
			pos  = "\t\t<Position>" + (helpers[i].pos.x /100)as string + "," + (helpers[i].pos.y /100)as string + "," + (helpers[i].pos.z /100)as string + "</Position>\n"
			rot  = "\t\t<Rotation>" + helpers[i].rotation.x as string + "," + helpers[i].rotation.y as string + "," + helpers[i].rotation.z as string + "," + helpers[i].rotation.w as string + "</Rotation>\n"
			
			prototype = "\t\t<Prototype>" + ActorProto[helpers[i].Actortype] + "</Prototype>\n"
			
			format "\t<LayoutEntry>\n" to: tempfile				
			format id to: tempfile				
			format type to: tempfile				
			format prototypefile to: tempfile				
			format pos to: tempfile				
			format rot to: tempfile				
			format prototype to: tempfile
			format "\t</LayoutEntry>\n" to: tempfile			
		)
	)	
)

---------------------------------------------------------------------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------------------------------------------------------------------
fn ExportLayoutFile = 
(	
	if (FindPlug() == false) then
	(
		messageBox "Scene must have CXL Plug Dummy to create layout file, script will now close."
		return;
		quit;
	)
	else
	(
		local newfile = maxFilePath + (getFilenameFile maxFileName) + "_base.layout"
		local LayoutFile = getSaveFilename caption:"Save layout file as......." types:"layout(*.layout)|*.layout" filename:newfile
	
		if LayoutFile == undefined then
		(
			--cancel pressed
			return;
			quit;
		)	
		
		LayoutFileName = (getFilenamePath LayoutFile) + (filenameFromPath LayoutFile)
		
		if (CreateXMLFile(LayoutFileName) == true) and (SetPlugPosition(LayoutFileName) == true) then
		(
			GenerateLayoutFile (LayoutFileName);
			local msg = "Success!!  Layout file:\"" + (filenameFromPath LayoutFileName) + "\" has been created in:\"" + (getFilenamePath LayoutFileName) + "\""
			messageBox msg		
		)
		else
		(
			messageBox "File creation failed, script will now close."
			return;
			quit;		
		)		
	)	
)

---------------------------------------------------------------------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------------------------------------------------------------------
fn GenerateLayoutFile layout = 
(
	
	local tempfilename = ((getFilenamePath layout) + (getFilenameFile layout) + ".temp")
	tempfile = createFile tempfilename
		
	AddTrees(tempfile)
	AddFurnitures(tempfile)
	AddActors(tempfile)
	
	close tempfile
	
	if ((getfiles layout).count != 0) then
	(
		local m = "<!--MaxLayout-->"
		local s = dotnetClass "System.IO.File"
		local t = dotnetClass "System.IO.File"
		tstring = t.ReadAllText tempfilename
		s.WriteAllText layout (substituteString (s.ReadAllText layout) m tstring)	
	)
	deletefile tempfilename
)

---------------------------------------------------------------------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------------------------------------------------------------------
fn SetPlugPosition layout = 
(
	local plugparams = FindPlug()
	local pos = ( floor plugparams.pos.x /100) as string + "," + ( floor plugparams.pos.y /100) as string + "," + ( floor plugparams.pos.z /100) as string
	local rot = plugparams.rotation.x as string + "," + plugparams.rotation.y as string + "," + plugparams.rotation.z as string + "," + plugparams.rotation.w as string
	
	if ((getfiles layout).count != 0) then
	(
		XmlDoc = DotNetObject "System.Xml.XmlDocument"
		XmlDoc.PreserveWhitespace = true;
		XmlDoc.load layout
		p = XmlDoc.selectsinglenode ("//Layout/LayoutEntry[ID = 'Plug']/Position")
		p.InnerText = pos 
		j = XmlDoc.selectsinglenode ("//Layout/LayoutEntry[ID = 'ParkingJunction']/Position")
		j.InnerText = pos 
		pr = XmlDoc.selectsinglenode ("//Layout/LayoutEntry[ID = 'Plug']/Rotation")
		pr.InnerText = rot
		jr = XmlDoc.selectsinglenode ("//Layout/LayoutEntry[ID = 'ParkingJunction']/Rotation")
		jr.InnerText = rot 
		XmlDoc.save layout
		return true;
	)
	else
	(
		messageBox "cannot find new layout file, script will now close."
		quit;
	)
)

---------------------------------------------------------------------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------------------------------------------------------------------
fn CreateXMLFile layout = 
(	
	dotNet.loadAssembly "system.xml"
	local Xml = workingdir + "\\b_base.layout"	
	
	if ((getfiles Xml).count != 0) then
	(
		XmlDoc = DotNetObject "System.Xml.XmlDocument"
		XmlDoc.PreserveWhitespace = true;
		XmlDoc.load Xml
		XmlDoc.save layout
		return true;
	)
	
	messageBox "b_base.layout not found."
	return false;
)


---------------------------------------------------------------------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------------------------------------------------------------------
fn LoadCXLFiles =
(
	T = openFile (workingdir + "\\CXL_Trees.cxl") mode:"r"
	F = openFile (workingdir + "\\CXL_Furnitures.cxl") mode:"r"
	A = openFile (workingdir + "\\CXL_Actors.cxl") mode:"r"
	if (T != undefined) and (F != undefined) and (A != undefined) then
	(
		while not EOF T do ( append CXL_Trees (readline T) )	
		
		while not EOF F do ( append CXL_Furnitures (readline F) )	
		
		while not EOF A do ( append CXL_Actors (readline A) )	
		
		Close T
		Close F
		Close A
		return true;
	)
	else
	(
		messageBox "Error: CXL Layout Plugin could not find CXL Files."
		return false;
	)
)

---------------------------------------------------------------------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------------------------------------------------------------------
fn FindThumb type imagename = 
(
	local thumbnail = (workingdir + "\\CXL_" + type + "\\" + imagename + ".jpg")
	local nothumb = (workingdir + "\\MissingThumb.jpg")
	if ((getfiles thumbnail).count != 0) then ( return thumbnail; )
	
	return nothumb;
)

---------------------------------------------------------------------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------------------------------------------------------------------
fn ReadCXLFile type list = 
(
	local CXLFileList = #()
	case type of
	(
		"Tree": CXLFileList = CXL_Trees
		"Furniture": CXLFileList = CXL_Furnitures
		"Actor": CXLFileList = CXL_Actors
	)
	local Name = #()
	local ID = #()
	local Proto = #()
	
	for i = 1 to CXLFileList.count do
	(	
		split = filterString (CXLFileList[i]) "|"
		Name[i] = split[1]
		ID[i] = split[2]
		Proto[i] = split[3]		
	)
		
	case list of
	(
		"Name":  return Name;
		"ID":    return ID;
		"Proto": return Proto;
	)
)

---------------------------------------------------------------------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------------------------------------------------------------------				
fn FindPlug = 
(
	for i = 1 to helpers.count do ( if (classof helpers[i] == CXLPLUG) and (helpers[i].name == "Plug") then ( return helpers[i] ) )	
	
	return false;
)


---------------------------------------------------------------------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------------------------------------------------------------------
if (CXLExport == true) then 
(
	ExportLayoutFile()
	CXLExport = undefined;
)


