-- CXL Layout File Tool Scripted Plugins.
-- version 1.0
-- by Altiris 2012
---------------------------------------------------------------------------------------------------------------------------------------------------

global CXL_Trees 	  = #()
global CXL_Furnitures = #()
global CXL_Actors     = #()
global MaxVer = ((maxVersion())[1]/1000.0)
FileIn "CXL_LayoutTool_Functions.ms"
LoadCXLFiles()

---------------------------------------------------------------------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------------------------------------------------------------------
plugin Helper CXLTREE name:"Tree" classID:#(0x48db14fe, 0x4e9b5f91) category:"CXL Layout Helpers" extends:dummy
(
	local meshObj
	parameters pblock rollout:params
	(
		presence type:#integer animatable:false ui:presencespinner default:100
		treescale type:#integer animatable:false ui:scalespinner default:75
		scalemin type:#integer animatable:false ui:minimumscale default:25
		scalemax type:#integer animatable:false ui:maximumscale default:75
		species type:#integer animatable:false ui:specieslist default:1
	) 
	
	rollout params "Tree Parameters"
	(	
		local TreeName = ReadCXLFile "Tree" "Name"
		local TreeID = ReadCXLFile "Tree" "ID"
		
		dropdownlist specieslist "" items:TreeName tooltip:"Choose Species" pos:[6,170] width:151 height:22
		
		bitmap speciesbitmap fileName:(FindThumb "Trees" TreeID[specieslist.selection]) pos:[6,5]
		
		label presencelabel "Presence Probability:" pos:[6,200]
		spinner presencespinner "" range:[10,100,100] type:#integer width:48 height:10 pos:[107,200] 
		
		label scalelabel "Scale:" pos:[6,224]
		spinner scalespinner "" range:[10,200,75] type:#integer  height:10 width:48 pos:[107,224]
		
		groupBox Randomscalebox "Random Scale:"  pos:[5,255] width:152 height:45
		
		label scaleminlabel "Min:" pos:[16,275]
		label scalemaxlabel "Max:" pos:[85,275]
		spinner minimumscale "" range:[10,200,20] type:#integer width:38 height:10 pos:[38,275] 
		spinner maximumscale "" range:[10,200,50] type:#integer width:38 height:10 pos:[110,275]

		on specieslist selected nameIndex do ( speciesbitmap.filename = (FindThumb "Trees" TreeID[specieslist.selection]) )
		
		on presencespinner changed prob do 
		( 
			if MaxVer >= 12 then (presencespinner.tooltip = prob as string + "%" )
		)
		
		on scalespinner changed ts do 
		( 
			if MaxVer >= 12 then (scalespinner.tooltip = ts as string + "%" )
		)
		
		on minimumscale changed minimum do 
		(
			if MaxVer >= 12 then (minimumscale.tooltip = minimum as string + "%" )
		)
		
		on maximumscale changed maximum do 
		(
			if MaxVer >= 12 then (maximumscale.tooltip = maximum as string + "%" )
		)
		
		on params open do
		(
			speciesbitmap.filename  = (FindThumb "Trees" TreeID[specieslist.selection])
			
			if MaxVer >= 12 then
			(
				minimumscale.tooltip    = minimumscale.value as string + "%"
				maximumscale.tooltip    = maximumscale.value as string + "%"
				presencespinner.tooltip = presencespinner.value as string + "%"
				scalespinner.tooltip    = scalespinner.value as string + "%"
			)
		)
	) 

	on getDisplayMesh do
	(
		if (meshObj == undefined) do ( meshObj = createInstance box length:50 width:50 height:200 mapCoords:false )

		meshObj.mesh
	)

	tool create 
	( 
		on mousePoint click do 
		( 	
			if click == 1 then
			(
				nodeTM.translation = gridPoint
				selection[1].wirecolor = [0,255,0]	
				#stop
			)
			
			if click == 2 then ( #stop )
		)
	)
) 


---------------------------------------------------------------------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------------------------------------------------------------------
plugin Helper CXLFURNITURE name:"Furniture" classID:#(0x45db14fe, 0x4e9b1f91) category:"CXL Layout Helpers" extends:dummy
(
	local meshObj
	parameters pblock rollout:params
	(
		presence type:#integer animatable:false ui:presencespinner default:100
		furniturescale type:#integer animatable:false ui:scalespinner default:100
		furnituretype type:#integer animatable:false ui:furniturelist default:1
	) 
	
	rollout params "Furniture Parameters"
	(	
		local FurnitureName = ReadCXLFile "Furniture" "Name"
		local FurnitureID = ReadCXLFile "Furniture" "ID"
		local FurnitureProto = ReadCXLFile "Furniture" "Proto"
		
		dropdownlist furniturelist "" items:FurnitureName tooltip:"Choose Furniture Object" pos:[6,170] width:151 height:22
		
		bitmap furniturebitmap fileName:(FindThumb "Furnitures" FurnitureID[furniturelist.selection]) pos:[6,5]
		
		label presencelabel "Presence Probability:" pos:[6,200]
		spinner presencespinner "" range:[10,100,100] type:#integer width:48 height:10 pos:[107,200] 
		
		label scalelabel "Scale:" pos:[6,224]
		spinner scalespinner "" range:[10,200,75] type:#integer  height:10 width:48 pos:[107,224]


		on furniturelist selected nameIndex do ( furniturebitmap.filename = (FindThumb "Furnitures" FurnitureID[furniturelist.selection]) )
		
		
		on presencespinner changed prob do ( if MaxVer >= 12 then ( presencespinner.tooltip = prob as string + "%" ))
		
		on scalespinner changed ts do ( if MaxVer >= 12 then (scalespinner.tooltip = ts as string + "%" ))
		
		on params open do
		(
			furniturebitmap.filename  = (FindThumb "Furnitures" FurnitureID[furniturelist.selection])
			if MaxVer >= 12 then
			(
				presencespinner.tooltip = presencespinner.value as string + "%"
				scalespinner.tooltip    = scalespinner.value as string + "%"
			)
		)
	) 

	on getDisplayMesh do
	(
		if (meshObj == undefined) do ( meshObj = createInstance box length:50 width:50 height:50 mapCoords:false )

		meshObj.mesh
	)

	tool create 
	( 
		on mousePoint click do 
		( 	
			if click == 1 then
			(
				nodeTM.translation = gridPoint
				selection[1].wirecolor = [0,255,255]	
				#stop
			)
			
			if click == 2 then ( #stop )
		)
	)
) 


---------------------------------------------------------------------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------------------------------------------------------------------
plugin Helper CXLACTOR name:"Actor" classID:#(0x46db14fe, 0x7e1b1f93) category:"CXL Layout Helpers" extends:dummy
(
	local meshObj
	parameters pblock rollout:params
	(
		Actortype type:#integer animatable:false ui:Actorlist default:1
	) 
	
	rollout params "Vehicle Parameters"
	(	
		local ActorName = ReadCXLFile "Actor" "Name"
		local ActorID = ReadCXLFile "Actor" "ID"
		local ActorProto = ReadCXLFile "Actor" "Proto"
		
		dropdownlist Actorlist "" items:ActorName tooltip:"Choose Vehicle" pos:[6,170] width:151 height:22
		
		bitmap Actorbitmap fileName:(FindThumb "Actors" ActorID[Actorlist.selection]) pos:[6,5]
		

		on Actorlist selected nameIndex do ( Actorbitmap.filename = (FindThumb "Actors" ActorID[Actorlist.selection]) )

		
		on params open do
		(
			Actorbitmap.filename  = (FindThumb "Actors" ActorID[Actorlist.selection])

		)
	) 

	on getDisplayMesh do
	(
		if (meshObj == undefined) do ( meshObj = createInstance box length:200 width:150 height:100 mapCoords:false )

		meshObj.mesh
	)

	tool create 
	( 
		on mousePoint click do 
		( 	
			if click == 1 then
			(
				nodeTM.translation = gridPoint
				selection[1].wirecolor = [255,255,0]	
				#stop
			)
			
			if click == 2 then ( #stop )
		)
	)
) 

---------------------------------------------------------------------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------------------------------------------------------------------
plugin Helper CXLPLUG name:"Plug" classID:#(0x47db14fe, 0x4e9b5f90) category:"CXL Layout Helpers" extends:dummy
(
	local meshObj

	on getDisplayMesh do
	(
		if (meshObj == undefined) do ( meshObj = createInstance box length:100 width:100 height:100 mapCoords:false )

		meshObj.mesh
	)

	tool create 
	( 
		on mousePoint click do 
		( 	
			if click == 1 then
			(
				if (FindPlug() != false) then
				(
					messagebox "Scene already has plug"
					max select none
					#stop
				)
				else	
				(
					nodeTM.translation = gridPoint
					selection[1].pivot = selection[1].center
					selection[1].name = "Plug"
					selection[1].wirecolor = [255,0,0]	
					#stop
				)
			)
			if click == 2 then ( #stop )
		)
	)
) 